import 'package:geiger_localstorage/geiger_localstorage.dart';
import 'variables.dart';
import 'function.dart';
import 'dart:convert';
import 'dart:async';
import 'listener.dart';
import 'dart:developer';

Future setValueListener() async{

//  for (var pluginsUUID in Storage.pluginUUIDs) {
//    await registerListener(Listener.sensorsValue,
//        ':' + Types.users + ':' + Storage.userUUID + ':' + pluginsUUID+':data:metrics');
//    await registerListener(Listener.sensorsValue,
//        ':' + Types.users + ':' + Storage.userUUID + ':' + '5a6487c7-c1c5-4f28-995e-8805e45bf1a3');

    await registerListener(Listener.sensorsValue,
        ':' + Types.users + ':' + Storage.userUUID,'GEIGERvalue');

    await registerListener(Listener.sensorsValue,
        ':' + Types.devices + ':' + Storage.deviceUUID,'GEIGERvalue');


    await registerListener(Listener.recommendation,
        ':' + Types.users + ':' + Storage.userUUID,'implementedRecommendations');

    await registerListener(Listener.recommendation,
        ':' + Types.devices + ':' + Storage.deviceUUID,'implementedRecommendations');



//    await registerListener(Listener.sensorsValue,
//        ':' + Types.devices + ':' + Storage.deviceUUID + ':' + pluginsUUID +
//            ':data:metrics');
//  }

}

Future getDevices() async {
  try {
    var temp = await Storage.controller!.get(':Devices');
    var getChildNodes = await temp.getChildNodesCsv();
    var devicesUUIDs = getChildNodes.toString().split(',');

    for (var uuid in devicesUUIDs) {
      var deviceNodesTemp = await Storage.controller!.get(':Devices:$uuid');
      var getChildren = await deviceNodesTemp.getChildren();
      //print(getChildren);
      //print(storage.userUUID);
      var deviceNodes = getChildren.entries.iterator;

      //await deviceNodesTemp.getChildren().asStream().forEach((element) { deviceNodes = element.entriesy.iterator;});
      //entries.iterator;

      try {
        deviceNodes.moveNext();
        var ownerNode = await deviceNodes.current.value.getValue('owner');
        if (ownerNode!.getValue('en') == Storage.userUUID) {
          var deviceScoreNode = await Storage.controller!.get(
              ':Devices:$uuid:' +
                  Storage.geigerIndicatorUUID +
                  ':data:GeigerScoreDevice');

          var geigerDevScore = deviceScoreNode.getValue('GEIGER_score');

          var geigerDevNumMetrics = deviceScoreNode.getValue('number_metrics');

          Node scoreNum = NodeImpl(':scnd', '');
          await scoreNum
              .addValue(NodeValueImpl('score', geigerDevScore.toString()));
          await scoreNum
              .addValue(NodeValueImpl('nums', geigerDevNumMetrics.toString()));
          CoreValues.aggregate.add(scoreNum);
        }
      } catch (e) {
        continue;
      }
    }
    // ignore: empty_catches
  } catch (e) {}
}

Future getEmployees() async {
  try {
    var userNode =
        await Storage.controller!.get(':Enterprise:users:' + Storage.userUUID);

    var mainUserNode = await userNode.getValue('mainUser');
    var flagmainUser = mainUserNode!.getValue('en');

    var supervisingNode = await userNode.getValue('supervising');
    var employeeNode = supervisingNode!.getValue('en');

    CoreValues.flagMainUser = flagmainUser == '1' ? true : false;

    if (employeeNode != null) {
      var employees = employeeNode.split(',');

      for (var empUUID in employees) {
        var userAggregateScoreNodeName = ':Users:' +
            empUUID +
            ':' +
            Storage.geigerIndicatorUUID +
            ':data:GeigerScoreAggregate';

        try {
          var userAggregateScoreNode =
              await Storage.controller!.get(userAggregateScoreNodeName);

          var scoreNode = await userAggregateScoreNode.getValue('GEIGER_score');
          var geigerAggScore = scoreNode!.getValue('en')!;

          var metricNode =
              await userAggregateScoreNode.getValue('number_metrics');
          var geigerAggNumMetrics = metricNode!.getValue('en')!;

          Node scoreNums = NodeImpl(':scn', '');
          await scoreNums.addValue(NodeValueImpl('score', geigerAggScore));
          await scoreNums.addValue(NodeValueImpl('nums', geigerAggNumMetrics));
          CoreValues.aggregate.add(scoreNums);
        } catch (e) {
          continue;
        }
      }
    }
  } catch (e) {
    // ignore: avoid_print
    log("api 117_ Dosen't have Enterprise Node");
    return;
  }
}

Future getEnterpriseUUID() async {
  try {
    var enterpriseNode = await Storage.controller!.get(':Enterprise');
    log('indiC getEnterpriseUUID1 enterpriseNode $enterpriseNode');
    var getChildren = await enterpriseNode.getChildren();
    log('indiC getEnterpriseUUID1 enterpriseNode $getChildren');
    var enterpriseNodeIterator = getChildren.entries.iterator;
    var profiles = [];

    while (enterpriseNodeIterator.moveNext()) {
      try {
        var sectorNode =
            await enterpriseNodeIterator.current.value.getValue('sector');
        var sector = sectorNode!.getValue('en');
        log('indiC getEnterpriseUUID1 sector $sector');

        var locationNode =
            await enterpriseNodeIterator.current.value.getValue('location');
        var location = locationNode!.getValue('en');
        log('indiC getEnterpriseUUID1 location $location');

        var profileNode = await enterpriseNodeIterator.current.value
            .getValue('associatedProfiles');
        var profile = profileNode!.getValue('en');
        log('indiC getEnterpriseUUID1 profile $profile');

        profiles.add(profile);

        CoreValues.enterpriseNode['sector'] = sector;
        CoreValues.enterpriseNode['location'] = location;
        CoreValues.enterpriseNode['associatedProfiles'] = profile;
      } catch (e) {
        //print(e);
        log('indiA getEnterpriseUUID1 ${e.toString()}');
        continue;
      }
    }

    return profiles;
  } catch (e) {

    log('indiA getEnterpriseUUID2 ${e.toString()}');
  }
}

Future getRisk() async {
  Node? profilesNode;
  try {
     profilesNode = await Storage.controller
  !.get(':Global:profiles');
  }catch (e) {

      log('indiA-getRisk1 ${e.toString()}');

      //print("':Global:profiles' doesn't exist in storage'===========");
//      print("Waiting ':Global:profiles'===========");
//      registerListener(Listener.profilesGlobal,':Global:profiles');
//
//      try{
//        List<Event> e = await Listener.profilesGlobal.getNumEvents(1);
//        print("Length of the Event ${e.length}");
//        if (e.isNotEmpty) {
//          getRecommendation();
//        }
//      } catch(e){
//      print(e);
//      }

  }

  try{
    var getChildren = await profilesNode!.getChildren();

    var profileNodeIterator = getChildren.entries.iterator;

    while (profileNodeIterator.moveNext()) {
      //print(profileNodeIterator.current.value);
      var nameNode = await profileNodeIterator.current.value.getValue('name');

      var profileName = nameNode!.getValue('en')!.toLowerCase();
      //log(profileName);

      for (String threatUUID in CoreValues.uuidThreats) {
        var threatUUIDNode =
            await profileNodeIterator.current.value.getValue(threatUUID);

        switch (profileName) {
          case Types.digitallyBased:
            CoreValues.based[threatUUID] = threatUUIDNode!.getValue('en')!;
            break;

          case Types.digitalEnabler:
            CoreValues.enabler[threatUUID] = threatUUIDNode!.getValue('en')!;
            break;

          case Types.digitallyDependent:
            CoreValues.dependent[threatUUID] = threatUUIDNode!.getValue('en')!;
            break;
        }
      }
    }
  } catch (e) {
      log('indiA-getRisk2 ${e.toString()}');

    return;
  }
}


Future getImplementedRecommendations(var uuid) async {
  try {
    var recommendationNode =
    await Storage.controller!.get(':Global:Recommendations:$uuid');


  var recommendationTypeNode = await recommendationNode.getValue('RecommendationType');

  var recommendationType = recommendationTypeNode!.getValue('en')!;

  var relatedThreatsWeightsNode = await recommendationNode.getValue('relatedThreatsWeights');
  var lists = relatedThreatsWeightsNode!.getValue('en')!.split(';'); //List<String>

  for (var node in lists) {
        var relatedThreatsWeights = node.split(',');
        //log('>>>$relatedThreatsWeights');
        Node impactNormal = NodeImpl(':ireco', '');
        await impactNormal.addValue(NodeValueImpl('impact', relatedThreatsWeights[1]));
        await impactNormal.addValue(NodeValueImpl('recuuid', uuid));
        var shortNode = await recommendationNode.getValue('short');
        await impactNormal.addValue(NodeValueImpl('short', shortNode!.getValue('en')!));
        var longNode = await recommendationNode.getValue('long');
        await impactNormal.addValue(NodeValueImpl('long', longNode!.getValue('en')!));


        if (recommendationType == Types.devices.toLowerCase()) {
            try {
                  if(relatedThreatsWeights[0].isNotEmpty) CoreValues.deviceImplementedRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
                  //CoreValues.deviceImplementedRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
            } catch (e) {
                  log("indiA - getReco 265");
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.deviceImplementedRecommendation[relatedThreatsWeights[0]] = temp;
            }
        } else {
            try {
                if(relatedThreatsWeights[0].isNotEmpty) CoreValues.userImplementedRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
                //CoreValues.userImplementedRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
            } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.userImplementedRecommendation[relatedThreatsWeights[0]] = temp;
            }
        }
  }

  } catch (e) {
    log("indiA - getReco 282");


  return;
  }
}


Future getRecommendation() async {
  try {
    var recommendationNode =
        await Storage.controller!.get(':Global:Recommendations');

    var getChildren = await recommendationNode.getChildren();

    var recoNodeIterator = getChildren.entries.iterator;

    while (recoNodeIterator.moveNext()) {
      var recommendationTypeNode =
          await recoNodeIterator.current.value.getValue('RecommendationType');

      var recommendationType = recommendationTypeNode!.getValue('en')!;
      //print('a$recommendationType');

      var relatedThreatsWeightsNode = await recoNodeIterator.current.value.getValue('relatedThreatsWeights');
      //print('b$relatedThreatsWeightsNode');
      var lists = relatedThreatsWeightsNode!.getValue('en')!.split(';'); //List<String>
      //print('c$lists');
      for (var node in lists) {
        var relatedThreatsWeights = node.split(',');
        //log('>>>$relatedThreatsWeights');

        Node impactNormal = NodeImpl(':reco', '');
        await impactNormal
            .addValue(NodeValueImpl('impact', relatedThreatsWeights[1]));
        await impactNormal
            .addValue(NodeValueImpl('recuuid', recoNodeIterator.current.key));
        var shortNode = await recoNodeIterator.current.value.getValue('short');
        await impactNormal
            .addValue(NodeValueImpl('short', shortNode!.getValue('en')!));

        var longNode = await recoNodeIterator.current.value.getValue('long');
        await impactNormal
            .addValue(NodeValueImpl('long', longNode!.getValue('en')!));

        //RecommendationType == types.Devices ? coreValues.deviceRecommendation[relatedThreatsWeights[0]]!.add(impactNormal) : coreValues.userRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);

        if (recommendationType == Types.devices.toLowerCase()) {
          try {
            if(relatedThreatsWeights[0].isNotEmpty) CoreValues.deviceRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
//            CoreValues.deviceRecommendation[relatedThreatsWeights[0]]!
//                .add(impactNormal);
          } catch (e) {
            var temp = <Node>[];
            temp.add(impactNormal);
            CoreValues.deviceRecommendation[relatedThreatsWeights[0]] = temp;
          }
        } else {
          try {
            if(relatedThreatsWeights[0].isNotEmpty) CoreValues.userRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
            //CoreValues.userRecommendation[relatedThreatsWeights[0]]!.add(impactNormal);
          } catch (e) {
            var temp = <Node>[];
            temp.add(impactNormal);
            CoreValues.userRecommendation[relatedThreatsWeights[0]] = temp;
          }
        }
      }
    }

  } catch (e) {

    log('indiA-getRecommendation - ${e.toString()}');
    //print('getRecommendation -348 $e');
    return;
  }
}


Future updateMetrics(var type,var node) async {

  log('>>>>>>updateMetrics');

  try {
    //var metricNode = await Storage.controller!.get(path.toString());
    var metricNode = node;
    var normalizationValue = await forUpdate(metricNode);
    var threatsImpactNode = await metricNode.getValue('threatsImpact');
    var threatsImpacts = threatsImpactNode!.getValue('en')!.split(';');


  for (var list in threatsImpacts) {
    var threatsImpact = list.split(',');

    var flagNode = await metricNode.getValue('flag');

  if (flagNode!.getValue('en') == '1') {
    Node impactNormal = NodeImpl(':upipn', '');
    await impactNormal
        .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
    await impactNormal.addOrUpdateValue(
    NodeValueImpl('normal', normalizationValue.toString()));

  //type == types.Devices ? coreValues.devicePositive[threatsImpact[0]]!.add(impactNormal) : coreValues.userPositive[threatsImpact[0]]!.add(impactNormal);

        if (type == Types.devices) {
              try {
                if(threatsImpact[0].isNotEmpty) CoreValues.devicePositive[threatsImpact[0]]!.add(impactNormal);
                //print(CoreValues.devicePositive);
              } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.devicePositive[threatsImpact[0]] = temp;
                //print(CoreValues.devicePositive);
              }
            } else {
              try {
                  if(threatsImpact[0].isNotEmpty) CoreValues.userPositive[threatsImpact[0]]!.add(impactNormal);
                  //CoreValues.userPositive[threatsImpact[0]]!.add(impactNormal);
                  //print(CoreValues.userPositive);
              } catch (e) {
                  var temp = <Node>[];
                  temp.add(impactNormal);
                  CoreValues.userPositive[threatsImpact[0]] = temp;

                //print(CoreValues.userPositive);
                }
            }
        } else {
            Node impactNormal = NodeImpl(':unipn', 'gg');
            await impactNormal
                .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
            await impactNormal.addOrUpdateValue(
            NodeValueImpl('normal', normalizationValue.toString()));
            //   type == types.Devices ? coreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal) : coreValues.userNegative[threatsImpact[0]]!.add(impactNormal);

            if (type == Types.devices) {
                  try {
                  if(threatsImpact[0].isNotEmpty) CoreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal);
                  //  CoreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal);
                  //print(CoreValues.deviceNegative);
                  } catch (e) {
                  var temp = <Node>[];
                  temp.add(impactNormal);
                  CoreValues.deviceNegative[threatsImpact[0]] = temp;
                  //print(CoreValues.deviceNegative);
                  }
            } else {
                try {
                if(threatsImpact[0].isNotEmpty) CoreValues.userNegative[threatsImpact[0]]!.add(impactNormal);
                //CoreValues.userNegative[threatsImpact[0]]!.add(impactNormal);
                //print(CoreValues.userNegative);
                } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.userNegative[threatsImpact[0]] = temp;
                //print(CoreValues.userNegative);
                }
            }
        }
  }

  }catch(e) {

    print(e);

  }

  print('>>>>>>updateMetrics>>>>>>>');

}


/*
Future updateMetrics(var type,var path) async {

  print('?! $type, $path');

  Node? metricNode;


  try {
      metricNode = await Storage.controller!.get(path);

  }catch(e) {
      print(e);

  }

  try{
  var childrenNodes = await metricNode!.getChildren();

  var metricNodeIterator = childrenNodes.entries.iterator;

  while (metricNodeIterator.moveNext()) {
  var normalizationValue = await normalization(metricNodeIterator);

  var threatsImpactNode =
  await metricNodeIterator.current.value.getValue('threatsImpact');

  var threatsImpacts = threatsImpactNode!.getValue('en')!.split(';');

  for (var list in threatsImpacts) {
  var threatsImpact = list.split(',');

  //  print(metricNodeIterator.current.value.getValue('flag')!.getValue('en'));
  var flagNode =
  await metricNodeIterator.current.value.getValue('flag');

  if (flagNode!.getValue('en') == '1') {
  Node impactNormal = NodeImpl(':upipn', '');
  await impactNormal
      .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
  await impactNormal.addOrUpdateValue(
  NodeValueImpl('normal', normalizationValue.toString()));

  //type == types.Devices ? coreValues.devicePositive[threatsImpact[0]]!.add(impactNormal) : coreValues.userPositive[threatsImpact[0]]!.add(impactNormal);

  if (type == Types.devices) {
  try {
  CoreValues.devicePositive[threatsImpact[0]]!.add(impactNormal);
  //print(CoreValues.devicePositive);
  } catch (e) {
  var temp = <Node>[];
  temp.add(impactNormal);
  CoreValues.devicePositive[threatsImpact[0]] = temp;
  //print(CoreValues.devicePositive);
  }
  } else {
  try {
  CoreValues.userPositive[threatsImpact[0]]!.add(impactNormal);
  //print(CoreValues.userPositive);
  } catch (e) {
  var temp = <Node>[];
  temp.add(impactNormal);
  CoreValues.userPositive[threatsImpact[0]] = temp;

  //print(CoreValues.userPositive);
  }
  }
  } else {
  Node impactNormal = NodeImpl(':unipn', 'gg');
  await impactNormal
      .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
  await impactNormal.addOrUpdateValue(
  NodeValueImpl('normal', normalizationValue.toString()));
  //   type == types.Devices ? coreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal) : coreValues.userNegative[threatsImpact[0]]!.add(impactNormal);

  if (type == Types.devices) {
  try {
  CoreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal);
  //print(CoreValues.deviceNegative);
  } catch (e) {
  var temp = <Node>[];
  temp.add(impactNormal);
  CoreValues.deviceNegative[threatsImpact[0]] = temp;
  //print(CoreValues.deviceNegative);
  }
  } else {
  try {
  CoreValues.userNegative[threatsImpact[0]]!.add(impactNormal);
  //print(CoreValues.userNegative);
  } catch (e) {
  var temp = <Node>[];
  temp.add(impactNormal);
  CoreValues.userNegative[threatsImpact[0]] = temp;
  //print(CoreValues.userNegative);
  }
  }
  }
  }
  }
  } catch (e) {
      print(e);
  }

}
*/



Future getMetrics(var type, var uuid) async {



  Node? metricNode;
  for (var path in Storage.getValuePath) {

      try {
         metricNode = await Storage.controller
    !.get(path);

    }catch(e) {

       log('indiA-getMetrics1 ${e.toString()}');
    }

  try{
  var childrenNodes = await metricNode!.getChildren();

      var metricNodeIterator = childrenNodes.entries.iterator;

      while (metricNodeIterator.moveNext()) {
        var normalizationValue = await normalization(metricNodeIterator);

        var threatsImpactNode =
            await metricNodeIterator.current.value.getValue('threatsImpact');

        var threatsImpacts = threatsImpactNode!.getValue('en')!.split(';');

        for (var list in threatsImpacts) {
          var threatsImpact = list.split(',');

          //  print(metricNodeIterator.current.value.getValue('flag')!.getValue('en'));
          var flagNode =
              await metricNodeIterator.current.value.getValue('flag');

          if (flagNode!.getValue('en') == '1') {
            Node impactNormal = NodeImpl(':pimn', 'gg');
            await impactNormal
                .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
            await impactNormal.addOrUpdateValue(
                NodeValueImpl('normal', normalizationValue.toString()));

            //type == types.Devices ? coreValues.devicePositive[threatsImpact[0]]!.add(impactNormal) : coreValues.userPositive[threatsImpact[0]]!.add(impactNormal);

            if (type == Types.devices) {
              try {
                  if(threatsImpact[0].isNotEmpty) CoreValues.devicePositive[threatsImpact[0]]!.add(impactNormal);
              } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.devicePositive[threatsImpact[0]] = temp;
                //print(CoreValues.devicePositive);
              }
            } else {
              try {
                if(threatsImpact[0].isNotEmpty) CoreValues.userPositive[threatsImpact[0]]!.add(impactNormal);
                //CoreValues.userPositive[threatsImpact[0]]!.add(impactNormal);
                //print(CoreValues.userPositive);
              } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.userPositive[threatsImpact[0]] = temp;

                //print(CoreValues.userPositive);
              }
            }
          } else {
            Node impactNormal = NodeImpl(':nimpn', 'gg');
            await impactNormal
                .addOrUpdateValue(NodeValueImpl('impact', threatsImpact[1]));
            await impactNormal.addOrUpdateValue(
                NodeValueImpl('normal', normalizationValue.toString()));
            //   type == types.Devices ? coreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal) : coreValues.userNegative[threatsImpact[0]]!.add(impactNormal);

            if (type == Types.devices) {
              try {
                if(threatsImpact[0].isNotEmpty) CoreValues.deviceNegative[threatsImpact[0]]!.add(impactNormal);
                //print(CoreValues.deviceNegative);
              } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.deviceNegative[threatsImpact[0]] = temp;
                //print(CoreValues.deviceNegative);
                }
            } else {
              try {
                if(threatsImpact[0].isNotEmpty) CoreValues.userNegative[threatsImpact[0]]!.add(impactNormal);
                //CoreValues.userNegative[threatsImpact[0]]!.add(impactNormal);
                //print(CoreValues.userNegative);
              } catch (e) {
                var temp = <Node>[];
                temp.add(impactNormal);
                CoreValues.userNegative[threatsImpact[0]] = temp;
                //print(CoreValues.userNegative);
              }
            }
          }
        }
      }
    } catch (e) {
        log('indiA-getMetrics2 ${e.toString()}');
        continue;
      }
  }
}

Future getExistScoreNodes(var type, var path) async {
  var uuid = '';
  type == Types.users ? uuid = Storage.userUUID : uuid = Storage.deviceUUID;

  try {
    var strPath =
        ':$type:' + uuid + ':' + Storage.geigerIndicatorUUID + ':data:$path';
    var node = await Storage.controller!.get(strPath);

    if (path == Types.geigerScoreUser || path == Types.geigerScoreDevice) {
      try {
        var temp = await node.getValue('implementedRecommendations');
        var ireco = temp!.getValue('en').toString().trim();
        var list = ireco.split(',');
        //log('implementedRecommendations >> $list');

        if(list.isNotEmpty && list.toString() != '[]') {
        for(String uuid in list){
          type == Types.users ? CoreValues.uuidUserImplementedRecommendations.add(uuid) : CoreValues.uuidDeviceImplementedRecommendations.add(uuid);
          getImplementedRecommendations(uuid);
        }
        //log('length of $type implementedRecommendations  >> ${type == Types.users ? CoreValues.uuidUserImplementedRecommendations.length : CoreValues.uuidDeviceImplementedRecommendations.length}');
        }
        }catch (e){
            log('indiB-getExistScoreNodesTure ${e.toString()}');
      }

    }
  } catch (e) {

    log('indiB-getExistScoreNodesFalse ${e.toString()}');

    if (path == Types.geigerScoreUser ||
        path == Types.geigerScoreDevice ||
        path == Types.geigerScoreAggregate) {
      await createScoreNode(type, path);
    } else if (path == Types.geigerScoreMSE) {
      await createScoreMSENode(type, path);
    } else if (path == Types.recommendations) {
      await createRecommendationNode(type);
    }
  }
}



Future createRecommendationNode(var type) async {
  var uuid = '';

  type == Types.users ? uuid = Storage.userUUID : uuid = Storage.deviceUUID;

  Node recommendationNode = NodeImpl('recommendations', '', ':$type:' + uuid + ':' + Storage.geigerIndicatorUUID + ':data');

  await Storage.controller!.add(recommendationNode);
}

Future updateRecommendationNode(var type) async {
  var uuid = '';

  type == Types.users ? uuid = Storage.userUUID : uuid = Storage.deviceUUID;

  try {
//    var recommendationNode = await Storage.controller!.get(':$type:' +
//        uuid +
//        ':' +
//        Storage.geigerIndicatorUUID +
//        ':data:recommendations');

    Node recommendationNode = NodeImpl(':$type:' + uuid + ':' + Storage.geigerIndicatorUUID + ':data:recommendations','');

    var threatRecoList = await crtRecommendation(type);

    for (NodeValue tr in threatRecoList) {
      await recommendationNode.addValue(tr);
    }

    //log('reco >>> $recommendationNode');

      await Storage.controller!.update(recommendationNode);

  } catch (e) {

    log('indiA - updateRecommendationNode ');
    return;
  }
}

Future createScoreMSENode(var type, var path) async {
  await Storage.controller!
      .addOrUpdate(NodeImpl(Storage.geigerIndicatorUUID,'',':$type'));
  await Storage.controller!
      .addOrUpdate(NodeImpl('data','' ,':$type:' + Storage.geigerIndicatorUUID));

  Node scoreMSENode =
      NodeImpl(':'+path, ':$type:' + Storage.geigerIndicatorUUID + ':data');

  //create node keys: UserScore, ImplementRecommendations
  NodeValue geigerScore =
      NodeValueImpl('GEIGER_score', '0'); //add node name (name of threat)
  await scoreMSENode.addOrUpdateValue(geigerScore);

  NodeValue location = NodeValueImpl('location', '');
  await scoreMSENode.addOrUpdateValue(location);

  NodeValue sector = NodeValueImpl('sector', '0');
  await scoreMSENode.addOrUpdateValue(sector);

  NodeValue associatedProfiles = NodeValueImpl('associatedProfiles', '0');
  await scoreMSENode.addOrUpdateValue(associatedProfiles);

  geigerScore.setDescription('GEIGER user score');

  await Storage.controller!.addOrUpdate(scoreMSENode);
}

void updateScoreMSENode() async {
  try {
    if (CoreValues.flagMainUser) {
      var scoreMSENode = await Storage.controller!.get(':Enterprise:' +
          Storage.geigerIndicatorUUID +
          ':data:GeigerScoreMSE');

      //create node keys: UserScore, ImplementRecommendations
      // ignore: non_constant_identifier_names
      NodeValue GEIGERScore = NodeValueImpl('GEIGER_score',
          CoreValues.gagg.toString()); //add node name (name of threat)
      scoreMSENode.updateValue(GEIGERScore);

      NodeValue location =
          NodeValueImpl('location', CoreValues.enterpriseNode['location']);
      scoreMSENode.updateValue(location);

      NodeValue sector =
          NodeValueImpl('sector', CoreValues.enterpriseNode['sector']);
      scoreMSENode.updateValue(sector);

      NodeValue associatedProfiles = NodeValueImpl('associatedProfiles',
          CoreValues.enterpriseNode['associatedProfiles']);
      scoreMSENode.updateValue(associatedProfiles);

      await Storage.controller!.addOrUpdate(scoreMSENode);
      // print(ScoreMSENode);
    }
  } catch (e) {
    // ignore: avoid_print
    print('api463$e');
  }
}

Future createScoreNode(var type, var path) async {
  var uuid = '';
  type == Types.users ? uuid = Storage.userUUID : uuid = Storage.deviceUUID;


  //print(':'+type+ ':'+ uuid + ':' + Storage.geigerIndicatorUUID + ':data'+path);
  Node geigerIndicatorUserScoreNode = NodeImpl(':'+type+ ':'+ uuid + ':' + Storage.geigerIndicatorUUID + ':data:$path','');
  //Node geigerIndicatorUserScoreNode = NodeImpl.createSkeleton(':'+type+ ':'+ uuid + ':' + Storage.geigerIndicatorUUID + ':data:'+path.toString().trim(),'',Storage.controller);
  //print(geigerIndicatorUserScoreNode.path);
  //create node keys: UserScore, ImplementRecommendations
  NodeValue geigerScore =
      NodeValueImpl('GEIGER_score', '0'); //add node name (name of threat)
  await geigerIndicatorUserScoreNode.addValue(geigerScore);

  NodeValue geigerThreatscores = NodeValueImpl('threats_score', '');
  await geigerIndicatorUserScoreNode.addValue(geigerThreatscores);

  NodeValue gegiernumMetrics = NodeValueImpl('number_metrics', '0');
  await geigerIndicatorUserScoreNode.addValue(gegiernumMetrics);

  geigerScore.setDescription('GEIGER user score');
  geigerThreatscores.setDescription('GEIGER threat-specific user score');
  gegiernumMetrics
      .setDescription('Number of metrics used in calculation of user score');

  if (path != Types.geigerScoreAggregate) {
    var implementedRecommendationsReco = '';
    type == Types.users ? implementedRecommendationsReco = CoreValues.uuidUserImplementedRecommendations.toString().replaceAll('[','').replaceAll(']','').trim() : implementedRecommendationsReco = CoreValues.uuidDeviceImplementedRecommendations.toString().replaceAll('[','').replaceAll(']','').trim();


    NodeValue implementedRecommendations = NodeValueImpl(
        'implementedRecommendations', implementedRecommendationsReco); //add node name (name of threat)
    await geigerIndicatorUserScoreNode.addValue(implementedRecommendations);



    try {
      await Storage.controller!.add(NodeImpl(Storage.geigerIndicatorUUID, '', ':$type:' + uuid));
      await Storage.controller!.add(NodeImpl('data', '', ':$type:' + uuid + ':' + Storage.geigerIndicatorUUID));
      await Storage.controller!.add(geigerIndicatorUserScoreNode);
    } catch (e) {
        log('indiA: createScoreNode 793- Exist GEIGER Score Node');
        //print(await storage.controller!.get(':$type:' + uuid + ':' + storage.GEIGERindicatorUUID + ':data:$path'));
    }
  } else {
    try {
      await Storage.controller!.add(geigerIndicatorUserScoreNode);
    } catch (e) {
      //print(e);
      log('indiA:  createScoreNode 801- Exist geigerScoreAggregate');
    }
  }
}

Future updateScoreNode(var type, var path) async {
  var uuid = '';
  type == Types.users ? uuid = Storage.userUUID : uuid = Storage.deviceUUID;

  Node scoreNode = NodeImpl(':$type:' + uuid + ':' + Storage.geigerIndicatorUUID + ':data:$path','');

    var geigerScore = 0.0;

  try{




    NodeValue geigerThreatscores = NodeValueImpl(
        'threats_score', await crtThreatScore(type));
    await  scoreNode.addValue(geigerThreatscores);

    type == Types.geigerScoreAggregate
        ? geigerScore = CoreValues.gagg
        : geigerScore = double.parse(await crtTotalThreatScore(type));
    log('indiC-updateScoreNode_geigerScore $geigerScore');
    } catch (e) {

      log('indiA-updateScoreNode 899 ${e.toString()}');
      return;
    }

    //GEIGER_score
    NodeValue geigerScoreNode =
        NodeValueImpl('GEIGER_score', geigerScore.toString());
    await  scoreNode.addValue(geigerScoreNode);



    var len = 0;

    try{
    type == Types.devices
        ? len =
            CoreValues.devicePositive.length + CoreValues.deviceNegative.length
        : len = CoreValues.userPositive.length + CoreValues.userNegative.length;
      } catch (e) {
      //print('api570$e');
      log('indiA-updateScoreNode 918 ${e.toString()}');
      return;
      }

  var numberMetrics = '';

    try{
    type == Types.geigerScoreAggregate
    ? numberMetrics = CoreValues.nagg.toString()
        : numberMetrics = len.toString();
    } catch (e) {
    //print('api582$e');
    log('indiA-updateScoreNode 931 ${e.toString()}');
    return;
    }
    NodeValue geigerNumMetrics = NodeValueImpl('number_metrics', numberMetrics);
    await scoreNode.addValue(geigerNumMetrics);

    if (path != Types.geigerScoreAggregate) {
      var implementedRecommendationsReco = '';
      type == Types.users ? implementedRecommendationsReco = CoreValues.uuidUserImplementedRecommendations.toString().replaceAll('[','').replaceAll(']','').trim() : implementedRecommendationsReco = CoreValues.uuidDeviceImplementedRecommendations.toString().replaceAll('[','').replaceAll(']','').trim();

      NodeValue implementedRecommendations =
          NodeValueImpl('implementedRecommendations',implementedRecommendationsReco);
      scoreNode.addValue(implementedRecommendations);

        try{

          await Storage.controller!.addOrUpdate(scoreNode);

        }catch(e){
           //   log('geiger-indicator: 874- Cannot Update GEIGER Score Node');
              log('indiA-updateScoreNode 950 ${e.toString()}');
        }

    } else {

      try{

        await Storage.controller!.addOrUpdate(scoreNode);

      }catch(e){
              //log('geiger-indicator: 874- Cannot Update geigerScoreAggregate Node');
              log('indiA-updateScoreNode 962 ${e.toString()}');
      }

    }


}



